<?php

/*****************************************
* File      :   includes/massuploadS_save.php
* Project   :   Massupload for Contenido
* Descr     :   Checks if there has been an error in the massuploaded file and sends corresponding response back to postlet.
*				If upload is ok, then the $_FILES arrays are copied in order to work with Contenido.
*
* Author    :   Karim Djelid
*               
* Created   :   6.12.2007
*
*  serv-it, www.serv-it.ch
*
******************************************/


if($_GET['massupload']=="yes" && $action == "upl_upload"){
	
	$allow_or_deny = true;					// Whether or not to allow the upload of specific files
	$allow_or_deny_method = "deny";			// If the above is true, then this states whether the array of files is a list of extensions to ALLOW, or DENY
	$file_extension_list = array("php","asp","pl");

	// ------- CHECK if there is no uploaded file.      												// All replies MUST start with "POSTLET REPLY", if they don't, then Postlet will not read the reply and will assume the file uploaded successfully.				
	if (!is_uploaded_file($_FILES['userfile']['tmp_name']) || $_FILES['userfile']['error']!=0){ 		// If the file can not be uploaded (most likely due to size), then output the correct error code			
		if (count($_FILES)==0 || $_FILES['userfile']['error']==1){										// If $_FILES is EMPTY, or $_FILES['userfile']['error']==1 then TOO LARGE
			header("HTTP/1.1 413 Request Entity Too Large");
			echo "POSTLET REPLY\r\n";
			echo "POSTLET:NO\r\n";
			echo "POSTLET:TOO LARGE\r\n";
			echo "POSTLET:ABORT THIS\r\n"; 								// Postlet should NOT send this file again.
			echo "END POSTLET REPLY\r\n";
			exit;
		}else if ($_FILES['userfile']['error']==6 || $_FILES['userfile']['error']==7){	// Unable to write the file to the server ALL WILL FAIL
			header("HTTP/1.1 500 Internal Server Error");
			echo "POSTLET REPLY\r\n";
			echo "POSTLET:NO\r\n";
			echo "POSTLET:SERVER ERROR\r\n";
			echo "POSTLET:ABORT ALL\r\n"; 								// Postlet should NOT send any more files
			echo "END POSTLET REPLY\r\n";
			exit;
		}else {															// Unsure of the error here (leaves 2,3,4, which means try again)
			header("HTTP/1.1 500 Internal Server Error");
			echo "POSTLET REPLY\r\n";
			echo "POSTLET:NO\r\n";
			echo "POSTLET:UNKNOWN ERROR\r\n";
			echo "POSTLET:RETRY\r\n";
			print_r($_REQUEST); 										// Possible usefull for debugging
			echo "END POSTLET REPLY\r\n";
			exit;
		}
	}

	// ------ Check if uploaded file is allowed -----------------------------------------------------------------------
	if ($allow_or_deny){
		if (($allow_or_deny_method == "allow" && !in_array(strtolower(array_pop(explode('.', $_FILES['userfile']['name']))), $file_extension_list))
			|| ($allow_or_deny_method == "deny" && in_array(strtolower(array_pop(explode('.', $_FILES['userfile']['name']))), $file_extension_list))){	
			header("HTTP/1.1 403 Forbidden");						// Atempt to upload a file with a specific extension when NOT allowed. // 403 error
			echo "POSTLET REPLY\r\n";
			echo "POSTLET:NO\r\n";
			echo "POSTLET:FILE TYPE NOT ALLOWED\r\n";
			echo "POSTLET:ABORT THIS\r\n"; 							// Postlet should NOT send this file again.
			echo "END POSTLET REPLY\r\n";
			exit;
		}
	}

	// ----- Copy the file array "userfile" to the file array "file" which is used by Contenido
	foreach($_FILES['userfile'] as $key => $value){
		$_FILES['file'][$key][]=$value;
	}

}

?>